<?php
error_reporting(E_ALL);

/*
		jGallery 2-RC1
		------------------------------------------------------------------
		support forums: www.jgallery.nl
		
<?php   
define ( 'jgall_inc_path' , 'jgallery/' ); 
define ( 'jgall_config_file' , 'config.conf' ) ;
include ( jgall_inc_path . 'index.php' );  
?>

*/



// ----------------------------------------------------------------------------------- 
// some frontcontrolers:
// -----------------------------------------------------------------------------------

$jgall = array();

$jgall['get']['dir'] = (isset($_GET['jgall_dir'])) ? str_replace('../','',strip_tags(str_replace('\\','/',$_GET['jgall_dir']))) : '' ;

$jgall['get']['cp'] = (isset($_GET['jgall_cp'])) ? str_replace('../','',strip_tags(str_replace('\\','/',$_GET['jgall_cp']))) : '' ;

$jgall['get']['slide'] = (isset($_GET['jgall_slide'])) ? str_replace('../','',strip_tags(str_replace('\\','/',$_GET['jgall_slide']))) : '' ;

$jgall['get']['img'] = (isset($_GET['jgall_img'])) ? str_replace('../','',strip_tags(str_replace('\\','/',$_GET['jgall_img']))) : '' ;

$jgall['get']['page'] = (isset($_GET['jgall_page'])) ? preg_replace('~[^0-9]~i','',$_GET['jgall_page']) : '' ;

$jgall['inc_path'] = ( defined( 'JGALL_INC_PATH' ) ) ? JGALL_INC_PATH : '' ;



// -----------------------------------------------------------------------------------
// Check install or die();
// -----------------------------------------------------------------------------------
include ( $jgall['inc_path'] . 'functions.inc.php' );
$jgall['user_gets'] = jgall_usergets();

$jgall['status']['writable'] = 0;
if ( file_exists( $jgall['inc_path'] . 'cache/status.php' ) )
{
   include ( $jgall['inc_path'] . 'cache/status.php' ) ;
}
if( $jgall['status']['settings'] != 'user' )
{
   if(headers_sent())
   {
      echo '<a href="'.$jgall['inc_path'].'install.php">Location: ./'.$jgall['inc_path'].'install.php</a>';
   }
   else
   {
      header('Location: ./install.php') ;
   }
   
   die();
}



// -----------------------------------------------------------------------------------
// general presets and important functions:
// -----------------------------------------------------------------------------------
include ( $jgall['inc_path'] . 'cache/settings.php' );
include ( $jgall['inc_path'] . 'cache/language.php' );
$jgall['gall_items'] = jgall_readdir($jgall['get']['dir'],'gall');
$jgall['dir_handle'] = 'cache/albums/' . $jgall['get']['dir'];
$jgall['dir_handle_array'] = explode ('/', $jgall['get']['dir']);
$jgall['dir_handle_count'] = count($jgall['dir_handle_array']);
$jgall['dir_handle_up'] = ($jgall['dir_handle_count'] > 2) ? $jgall['dir_handle_array'][$jgall['dir_handle_count']-3] . '/' : '' ;
$jgall['dir_handle_current'] = ($jgall['dir_handle_count'] > 1) ? $jgall['dir_handle_array'][$jgall['dir_handle_count']-2] : $jgall['lang']['mainfolder'] ;
$jgall['config']['view_slideshow_size'] = array('image' => $jgall['config']['view_slideshow_size'], 'width' => $jgall['config']['view_slideshow_size']+24, 'height' => $jgall['config']['view_slideshow_size']+50);
$jgall['slideshow_uri'] = (!empty($jgall['get']['img'])) ? $jgall['inc_path'] . 'index.php?jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['get']['img'] . '&jgall_slide=play' : $jgall['inc_path'] . 'index.php?jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['gall_items']['first'] . '&jgall_slide=play' ;





// -----------------------------------------------------------------------------------
// calculate number of pages ($jgall['pages'])
// -----------------------------------------------------------------------------------
$jgall['full_page'] = $jgall['config']['thumbnail_cols'] * $jgall['config']['thumbnail_rows'];
$jgall['pages'] = ceil($jgall['gall_items']['total'] / $jgall['full_page']);
if(!empty($jgall['get']['page'])) 
{
   $jgall['current_page'] = $jgall['get']['page']-1;
   $jgall['i_pages'] = $jgall['current_page']*($jgall['config']['thumbnail_cols']*$jgall['config']['thumbnail_rows']);
   $jgall['max'] = $jgall['i_pages']+($jgall['config']['thumbnail_cols']*$jgall['config']['thumbnail_rows']);
   if($jgall['max'] > $jgall['gall_items']['total']) 
   {
      $jgall['max'] = $jgall['gall_items']['total'];
   }
}
else 
{
   $jgall['i_pages'] = '0';
   $jgall['max'] = $jgall['config']['thumbnail_cols']*$jgall['config']['thumbnail_rows'];
   if ($jgall['max'] > $jgall['gall_items']['total']) {
      $jgall['max'] = $jgall['gall_items']['total'];
   }
}
$jgall['temp_start'] = $jgall['i_pages'];



// -----------------------------------------------------------------------------------
// create menu bar
// -----------------------------------------------------------------------------------
$jgall['tpl_array']['menu'] = array(

   'mainfolder' => $jgall['lang']['mainfolder'],
   
   'button_home' => '<img src="' . $jgall['inc_path'] . 'template/' . $jgall['config']['template'] . '/images/home-gray.png" border="0" align="middle" title="' . jgall_parse_language('home') . '">',
   
   'button_up' => '<img src="' . $jgall['inc_path'] . 'template/' . $jgall['config']['template'] . '/images/up-gray.png" border="0" align="middle" title="' . jgall_parse_language('up') . '">',
   
   'foldercrumb' => '',
   
   'currentimg' => ''
   
);

$jgall['key_current'] = 0;

if((!empty($jgall['get']['dir'])) or ($jgall['get']['page'] > 1) or !empty($jgall['get']['img']))

{

   $jgall['tpl_array']['menu']['button_home'] = '<a href="' . $jgall['user_gets'] . 'jgall_dir"><img src="' . $jgall['inc_path'] . 'template/' . $jgall['config']['template'] . '/images/home.png" border="0" align="middle" title="' . jgall_parse_language('gohome') . '"></a>';
   
   if(!empty($jgall['get']['dir']))
   
   {
   
      $jgall['tpl_array']['menu']['mainfolder'] = '<a href="'.$jgall['user_gets'].'jgall_dir" class="jgall_menubar_link">' . $jgall['lang']['mainfolder'] . '</a>' . $jgall['config']['breadcrumb_devider'];
      
      $jgall['tpl_array']['menu']['button_up'] = '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['dir_handle_up'] . '"><img src="' . $jgall['inc_path'] . 'template/' . $jgall['config']['template'] . '/images/up.png" border="0" align="middle" title="' . jgall_parse_language('goup') . '"></a>';
      
      $jgall['key_current'] = $jgall['dir_handle_count']-2;
      
   }
   
   elseif(!empty($jgall['get']['img']) && file_exists($jgall['inc_path'] . $jgall['dir_handle'] . $jgall['get']['img']))
   
   {
   
      $jgall['tpl_array']['menu']['mainfolder'] = '<a href="' . $jgall['user_gets'] . 'jgall_dir=&jgall_page=' . $jgall['gall_items']['current']['page'] . '" class="jgall_menubar_link">' . $jgall['lang']['mainfolder'] . '</a>';
      
   }
   
}

$jgall['crumb'] = '';

for($jgall['i_crumb']=1; $jgall['i_crumb'] < $jgall['dir_handle_count']-1; $jgall['i_crumb']++)

{

   $jgall['crumb'] .= $jgall['dir_handle_array'][$jgall['i_crumb']-1].'/';
   
   $jgall['tpl_array']['menu']['foldercrumb'] .= '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['crumb'] . '" class="jgall_menubar_link">' . $jgall['dir_handle_array'][$jgall['i_crumb']-1] . '</a>' . $jgall['config']['breadcrumb_devider'];
   
}

if(!empty($jgall['get']['img']) && file_exists($jgall['inc_path'] . $jgall['dir_handle'] . $jgall['get']['img']))

{

   $jgall['tpl_array']['menu']['foldercrumb'] .= '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'] . '&jgall_page=' . $jgall['gall_items']['current']['page'] . '" class="jgall_menubar_link">' . $jgall['dir_handle_array'][$jgall['i_crumb']-1] . '</a>';
   
   $jgall['tpl_array']['menu']['currentimg'] .= $jgall['config']['breadcrumb_devider'] . $jgall['get']['img'];
   
}

else

{

   $jgall['tpl_array']['menu']['foldercrumb'] .= $jgall['dir_handle_array'][$jgall['key_current']] ;
   
}



// -----------------------------------------------------------------------------------
// output thumbnails or view image 
// -----------------------------------------------------------------------------------

// viewing controle-panel
if(!empty($jgall['get']['cp']))
{
   include($jgall['inc_path']. 'cp_admin.php' );
   echo jgall_parse_tpl('admin_cp');
}


// viewing slideshow
elseif(!empty($jgall['get']['slide']))
{
   $jgall['get']['img'] = (empty($jgall['get']['img']) or !file_exists($jgall['inc_path'].$jgall['dir_handle'].$jgall['get']['img'])) ? $jgall['gall_items']['first'] : $jgall['get']['img'] ;
   $jgall['tpl_array']['slideshow']['next_image'] = ($jgall['gall_items']['current']['name'] != $jgall['gall_items']['last']) ? $jgall['gall_items']['next'] : $jgall['gall_items']['first'] ;
   $jgall['tpl_array']['slideshow']['image'] = '<img name="image" ' . jgall_resize($jgall['gall_items']['current']['info'],$jgall['config']['view_slideshow_size']['image']) . ' border="0" src="' . $jgall['inc_path'] . 'thumb.php?src=' . $jgall['dir_handle'] . $jgall['get']['img'] . '&size=' . $jgall['config']['view_slideshow_size']['image'] . '&ratio=OAR" class="jgall_slide_image">';
   echo jgall_parse_tpl('slideshow');
}


// viewing image
elseif(!empty($jgall['get']['img']) && file_exists($jgall['inc_path'].$jgall['dir_handle'].$jgall['get']['img']))

{

   // create pagelinks
   if(!empty($jgall['gall_items']['total']) && (($jgall['gall_items']['total'] > $jgall['full_page']) or (!empty($jgall['get']['img']))))
   {
   
      //  first | prev
      $jgall['tpl_array']['pagelinks']['links'] = ($jgall['gall_items']['current']['num'] > 1) ? '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['gall_items'][$jgall['gall_items']['directorys']]['name'] . '" class="jgall_pagelinks_link">' . $jgall['lang']['first'] . '</a>' . $jgall['config']['pagelink_devider'] . '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['gall_items']['prev'] . '" class="jgall_pagelinks_link">' . $jgall['lang']['prev'] . '</a>' . $jgall['config']['pagelink_devider'] : '' ;

      // image {current} of {total}
      $jgall['tpl_array']['pagelinks']['links'] .= jgall_parse_language('image_info');

      // next | last 
      $jgall['tpl_array']['pagelinks']['links'] .= ($jgall['gall_items']['current']['num'] < $jgall['gall_items']['images']) ? $jgall['config']['pagelink_devider'] . '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['gall_items']['next'] . '" class="jgall_pagelinks_link">' . $jgall['lang']['next'] . '</a>' . $jgall['config']['pagelink_devider'] . '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'].'&jgall_img=' . $jgall['gall_items']['last'] . '" class="jgall_pagelinks_link">' . $jgall['lang']['last'] . '</a>' : '' ;
      
   }

   $jgall['image_link_start'] = '<a href="' . $jgall['inc_path'] . $jgall['dir_handle'] . $jgall['get']['img'] . '" target="_blank" title="' . $jgall['lang']['downloadimage'] . ': ' . $jgall['get']['img'] . '">' ;
   
   $jgall['image_link_end'] = '</a>' ;
   
   $jgall['tpl_array']['gallery']['image'] = $jgall['image_link_start'] . '<img name="image" ' . jgall_resize($jgall['gall_items']['current']['info'],$jgall['config']['view_img_size']) . ' border="0" src="' . $jgall['inc_path'] . 'thumb.php?src=' . $jgall['dir_handle'] . $jgall['get']['img'] . '&size=' . $jgall['config']['view_img_size'] . '&ratio=OAR">' . $jgall['image_link_end'];

   echo jgall_parse_tpl('jgallery');
   
}



// viewing thumbnails
else

{

   $jgall['tpl_array']['gallery']['folderthumb'] = $jgall['inc_path'] . 'cache/thumbs/template[DIR]' . $jgall['config']['template'] . '[DIR]images[DIR]folder.jpg';

   if ( file_exists($jgall['tpl_array']['gallery']['folderthumb']) )
   {
      $jgall['tpl_array']['gallery']['folderthumbsize'] = getimagesize( $jgall['tpl_array']['gallery']['folderthumb'] );
   }
   else
   {
      $jgall['tpl_array']['gallery']['folderthumbsize'] = array(0,0);
   }

   $jgall['tpl_array']['gallery']['folderimage'] = (($jgall['tpl_array']['gallery']['folderthumbsize'][0] == $jgall['config']['thumbnail_size']) && ($jgall['tpl_array']['gallery']['folderthumbsize'][1] == $jgall['config']['thumbnail_size']) ) ? $jgall['tpl_array']['gallery']['folderthumb'] : $jgall['inc_path'] . 'thumb.php?src=template/' . $jgall['config']['template'] . '/images/folder.jpg&size=' . $jgall['config']['thumbnail_size'] . '&ratio=' . $jgall['config']['thumbnail_display_mode'] . '&save=' . $jgall['status']['writable'] ;

   $jgall['tpl_array']['gallery']['thumbs'] = '';
   
   if ($jgall['pages'] > 1) 
   {
   
      $jgall['current'] = ( !empty($jgall['get']['page'] ) && is_numeric( $jgall['get']['page'] ) ) ? $jgall['get']['page'] : 1;
      
      //  first | prev
      $jgall['tpl_array']['pagelinks']['links'] =  ($jgall['current'] > '1') ? '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'] . '&jgall_page=1" class="jgall_pagelinks_link">' . $jgall['lang']['first'] . '</a>' . $jgall['config']['pagelink_devider'] . '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'] . '&jgall_page=' . ($jgall['current']-1) . '" class="jgall_pagelinks_link">' . $jgall['lang']['prev'] . '</a>' . $jgall['config']['pagelink_devider'] : '' ;
         
      for ($i=1; $i<=$jgall['pages']; $i++)
      {
      
         $jgall['tpl_array']['pagelinks']['links'] .=  ($i == $jgall['current']) ? '&nbsp;<b>' . $i . '</b>&nbsp;' : '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'] . '&jgall_page='. $i .'" class="jgall_pagelinks_link">&nbsp;<b>' . $i . '</b>&nbsp;</a>' ;
         
      }
      
      // next | last 
      $jgall['tpl_array']['pagelinks']['links'] .=  ($jgall['current'] < $jgall['pages']) ? $jgall['config']['pagelink_devider'] . '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'] . '&jgall_page=' . ($jgall['current']+1) . '" class="jgall_pagelinks_link">' . $jgall['lang']['next'] . '</a>' . $jgall['config']['pagelink_devider'] . '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'] . '&jgall_page=' . $jgall['pages'] . '" class="jgall_pagelinks_link">' . $jgall['lang']['last'] . '</a>' : '' ;
         
      }
   
   if (!empty($jgall['gall_items']['total']))
   
   {
   
      $c_jgall['x'] = '0'; 
      
      $c_jgall['y'] = '0';
      
      for ($jgall['i_pages']=$jgall['i_pages']; $jgall['i_pages']<=$jgall['max']-1; $jgall['i_pages']++)
      
      {

         $c_jgall['x']++;

         if($c_jgall['x'] == 1)
         
         {
         
            $jgall['tpl_array']['gallery']['thumbs'] .= '   <tr class="jgall_tablerow">';
            
            $c_jgall['y']++;
            
         }
         
         // for folders
         if ($jgall['gall_items'][$jgall['i_pages']]['type'] != 'image') 
         
         {

            $jgall['tpl_array']['gallery']['location_href'] = $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'] . $jgall['gall_items'][$jgall['i_pages']]['name'] . '/';
            
            $jgall['tpl_array']['gallery']['textlink'] = '<a href="' . $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'] . $jgall['gall_items'][$jgall['i_pages']]['name'] . '/' . '">' . $jgall['gall_items'][$jgall['i_pages']]['name'] . '</a>';
            
            $jgall['tpl_array']['gallery']['thumbs'] .= jgall_parse_tpl('thumb_folder');
            
         }
         
         // for images
         else
         
         {
            
            $jgall['tpl_array']['gallery']['location_href'] = $jgall['user_gets'] . 'jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['gall_items'][$jgall['i_pages']]['name'];
            
            $jgall['tpl_array']['gallery']['thumb_demensions'] = ($jgall['config']['thumbnail_display_mode'] == "OAR") ? jgall_resize($jgall['gall_items'][$jgall['i_pages']]['info'],$jgall['config']['thumbnail_size']) : 'width="' . $jgall['config']['thumbnail_size'] . '" height="' . $jgall['config']['thumbnail_size'] . '"';
            
            $jgall['tpl_array']['gallery']['thumb_title'] = $jgall['gall_items'][$jgall['i_pages']]['name'] ;
            // check for thumbnail
            $jgall['tpl_array']['gallery']['thumb_src'] =  $jgall['inc_path'] . 'cache/thumbs/' . preg_replace( '~[^\w\.\[\]]~' , '_' , str_replace ( '/' , '[DIR]' , str_replace ( 'cache/albums/' , '' , $jgall['dir_handle'] . $jgall['gall_items'][$jgall['i_pages']]['name'] ) ) ) ;

            $jgall['tpl_array']['gallery']['cached_ts'] = ( file_exists( $jgall['tpl_array']['gallery']['thumb_src'] ) ) ? getimagesize( $jgall['tpl_array']['gallery']['thumb_src'] ) : array( 3 => 'notfound' ) ;

            $jgall['tpl_array']['gallery']['img_src'] = ( $jgall['tpl_array']['gallery']['thumb_demensions'] == $jgall['tpl_array']['gallery']['cached_ts'][3] ) ? $jgall['tpl_array']['gallery']['thumb_src'] : $jgall['inc_path'] . 'thumb.php?src=' . $jgall['dir_handle'] . $jgall['gall_items'][$jgall['i_pages']]['name'] . '&size=' . $jgall['config']['thumbnail_size'] . '&ratio=' . $jgall['config']['thumbnail_display_mode'] . '&save=' . $jgall['status']['writable'] ;
            
            $jgall['tpl_array']['gallery']['thumbs'] .= jgall_parse_tpl('thumb_image');
            
         }
         
         if ($c_jgall['x'] == $jgall['config']['thumbnail_cols']) 
         
         {
         
            $jgall['tpl_array']['gallery']['thumbs'] .= '</tr>';
            
            $c_jgall['x'] = '0';
            
         }
         
      }
      
      if($c_jgall['x'] != '0') 
      
      {
      
         $jgall['tpl_array']['gallery']['thumbs'] .= '</tr>';
         
      }
      
   }
   
   else
   
   {
   
      $jgall['tpl_array']['gallery']['thumbs'] = jgall_parse_tpl('emptydir');
      
   }

   echo jgall_parse_tpl('jgallery');
   
}


if(!empty($_GET['debug']) && ($_GET['debug'] == 'y' or $_GET['debug'] == 'all'))
{
   jgall_vardump();
}

// --> end
?>
