<?php
/*
		jGallery 2-RC2
		------------------------------------------------------------------
		support forums: http://www.jgallery.nl
*/







// ----------------------------------------------------------------------------------- 
// function to retreve image information
// ----------------------------------------------------------------------------------- 
function jgall_getimagesize($path)
{
   global $jgall;
   
}



// ----------------------------------------------------------------------------------- 
// function to read dir and return values
// ----------------------------------------------------------------------------------- 
function jgall_readdir($dir='',$return='gall',$sort='no')
{
   global $jgall;
   
   $extentions = "jpg|jpeg|gif|png";
   
   $images = array();
   $directorys = array();
   $gallery_items = array();
   $namearray = array();

   if($dirhandle = opendir($jgall['inc_path'] . 'cache/albums/' . $dir))
   {
      while(false !== ($file = readdir($dirhandle))) 
      {
         if($file != '.' && $file != '..')
         {
            if(is_dir($jgall['inc_path'] . 'cache/albums/' . $dir . $file))
            {
               $directorys[] = array(
                  'type' => 'dir',
                  'name' => $file,
                  'first_image' => jgall_readdir($dir . $file . '/','first',$sort),
                  'content' => $jgall['gall_items']['dir_content'][0]
               );
               unset($jgall['gall_items']['dir_content']);
            }
            elseif(eregi($extentions,jgall_ext($file)))
            {
               $getimagesize = getimagesize($jgall['inc_path'] . 'cache/albums/' . $dir . $file);
               $mime = (isset($getimagesize['mime'])) ? explode('/',$getimagesize['mime']) : 'no_mime_found';
               if(eregi($extentions,$mime[1]))
               {
                  $images[] = array(
                     'type' => 'image',
                     'name' => $file,
                     'size' => filesize($jgall['inc_path'] . 'cache/albums/' . $dir . $file),
                     'info' => $getimagesize
                  );
                  $namearray[] = $file;
                  if(!empty($jgall['get']['img']) && $file == $jgall['get']['img'])
                  {
                     $current = $file;
                  }
               }
            }
         }
      }
      closedir($dirhandle);
      
      // add more sort functions here
      sort($directorys);
      sort($images);
      
      if($return == 'first')
      {
         $jgall['gall_items']['dir_content'][] = array(count($images),count($directorys));
         $folderthumb_size = ceil($jgall['config']['thumbnail_size'] / 100 * 80);
         if(empty($images) && empty($directorys))
         {
            $src = 'question';
            $getimagesize = getimagesize($jgall['inc_path'] . 'template/' . $jgall['config']['template'] . '/images/no_image.jpg');
            $html_size = jgall_resize($getimagesize,$folderthumb_size);
            return '<img ' . $html_size . ' border="0" src="' . $jgall['inc_path'] . 'thumb.php?src=' . $src . '&theme=' . $jgall['config']['template'] . '&size=' . $folderthumb_size . '" class="jgall_thumb_image" />';
         }
         elseif(empty($images) && !empty($directorys))
         {
            return jgall_readdir($dir . $directorys[0]['name'] . '/','first',$sort);
         }
         else
         {
            $src = 'cache/albums/' . $dir . $images[0]['name'];
            $html_size = ($jgall['config']['thumbnail_display_mode'] == "OAR") ? jgall_resize($images[0]['info'],$folderthumb_size) : 'width="' . $folderthumb_size . '" height="' . $folderthumb_size . '"' ;
            return '<img ' . $html_size . ' border="0" src="' . $jgall['inc_path'] . 'thumb.php?src=' . $src . '&size=' . $folderthumb_size . '&ratio=' . $jgall['config']['thumbnail_display_mode'] . '" class="jgall_thumb_image" />';
         }
      }
      elseif($return == 'gall')
      {
         $gallery_items = array_merge($directorys,$images);
         $gallery_items['images'] = count($images);
         $gallery_items['directorys'] = count($directorys);
         $gallery_items['total'] = $gallery_items['directorys'] + $gallery_items['images'];
         $gallery_items['names'] = $namearray;
         $gallery_items['first'] = ($gallery_items['images'] > 0) ? $gallery_items[$gallery_items['directorys']]['name'] : '' ;
         if(!empty($jgall['get']['img']))
         {
            for($i=$gallery_items['directorys']; $i<$gallery_items['total']; $i++)
            {
               if($gallery_items[$i]['name'] == $current)
               {
                  $gallery_items['prev'] = ($i > $gallery_items['directorys']) ? $gallery_items[$i-1]['name'] : '';
                  $gallery_items['current'] = array(
                     'num' => $i - $gallery_items['directorys'] + 1,
                     'name' => $gallery_items[$i]['name'],
                     'page' => floor($i / ($jgall['config']['thumbnail_cols'] * $jgall['config']['thumbnail_rows'])) + 1,
                     'size' => $gallery_items[$i]['size'],
                     'info' => $gallery_items[$i]['info']
                  );
                  $gallery_items['next'] = ($i < $gallery_items['total']-1) ? $gallery_items[$i+1]['name'] : '';
               }
            }
            $gallery_items['last'] = $gallery_items[$gallery_items['total']-1]['name'];
         }
         return $gallery_items;
      }
   }
   else
   {
      die('<br /><br /><b>fatal error</b>: could not read directory: \'' . $jgall['inc_path'] . $jgall['config']['album_root'] . $dir . '\'. <br /><br /><a href="?jgall_dir">back to main</a>');
   }
}



// ----------------------------------------------------------------------------------- 
// function to get extention 
// ----------------------------------------------------------------------------------- 
function jgall_ext($filename, $return=FALSE)
{
   $filenamearray = explode('.',$filename);
   if($return == 'NAME')
   {
      unset($filenamearray[count($filenamearray)-1]);
      $temp = implode($filenamearray,'.');
      return($temp);
   }
   else
   { 
       return($filenamearray[count($filenamearray)-1]);
   }
} // end function jgall_ext




// ----------------------------------------------------------------------------------- 
// function to parse template parts
// -----------------------------------------------------------------------------------
function jgall_parse_tpl($part)
{

   global $jgall;
   
   $global_regs = array (
      'VERSION' => $jgall['status']['build'],
      'INCLUDE_PATH' => $jgall['inc_path'],
      'TEMPLATE' => $jgall['config']['template'],
   );
   
   switch($part)
   {
   
      case "html_header":
         $regs = array(
            'TITLE' => jgall_parse_language('title'),
         );
         break;
         
      case "jgallery":
         $regs = array (
            'HTML_HEADER' => (empty($jgall['inc_path'])) ? jgall_parse_tpl('html_header') : '' ,
            'TPL_MENUBAR' => jgall_parse_tpl('menubar'),
            'TPL_GALLERY' => (!empty($jgall['get']['img']) && file_exists($jgall['inc_path'].$jgall['dir_handle'].$jgall['get']['img'])) ? jgall_parse_tpl('view_image') : $jgall['tpl_array']['gallery']['thumbs'] ,
            'TPL_PAGELINKS' => (isset($jgall['tpl_array']['pagelinks']['links'])) ? jgall_parse_tpl('pagelinks') : '' ,
            'TPL_DIR_INFO' => jgall_parse_tpl('dir_info') ,
            'HTML_FOOTER' => (empty($jgall['inc_path'])) ? jgall_parse_tpl('html_footer') : '' ,
         );
         break;
         
      case "menubar":
         $regs = array (
            'L_LOCATION' => $jgall['lang']['location'],
            'FOLDERCRUMB' => $jgall['tpl_array']['menu']['mainfolder'] . $jgall['tpl_array']['menu']['foldercrumb'] . $jgall['tpl_array']['menu']['currentimg'],
            'BUTTON_HOME' => $jgall['tpl_array']['menu']['button_home'],
            'BUTTON_UP' => $jgall['tpl_array']['menu']['button_up'],
            'BUTTON_REFRESH' => '<a href="javascript:location.reload();" target="_self"><img src="' . $jgall['inc_path'] . 'template/' . $jgall['config']['template'] . '/images/refresh.png" border="0" align="middle" title="'.jgall_parse_language('refresh').'"></a>',
            'BUTTON_PRESENTATION' => ($jgall['gall_items']['images'] > 0) ? '<a href="javascript:void(0)" onclick="window.open(\''.$jgall['slideshow_uri'].'\',\''.date("dhis").'\',\'width='.$jgall['config']['view_slideshow_size']['width'].',height='.$jgall['config']['view_slideshow_size']['height'].',menu=no,location=no,status=no,resizeable=no,scrollbars=no\')"><img src="' . $jgall['inc_path'] . 'template/' . $jgall['config']['template'] . '/images/slideshow.png" border="0" align="middle" title="'.jgall_parse_language('start_slideshow').'"></a>' : '<img src="' . $jgall['inc_path'] . 'template/' . $jgall['config']['template'] . '/images/slideshow-gray.png" border="0" align="middle" title="start slideshow in popup window">',
            'BUTTON_CP' => '<a href="javascript:void(0)" onclick="window.open(\'' . $jgall['inc_path'] . 'ft2.php\',\''.date("mdhis").'\',\'width=750,height=550,menu=no,location=no,status=no,resizeable=no,scrollbars=no\')"><img src="' . $jgall['inc_path'] . 'template/' . $jgall['config']['template'] . '/images/system.png" border="0" align="middle" title="'.jgall_parse_language('manage_album').'"></a>',
            'BUTTON_HELP' => '<a href="http://www.jgallery.nl/?rel=' . $jgall['status']['build'] . '" target="_blank"><img src="' . $jgall['inc_path'] . 'template/' . $jgall['config']['template'] . '/images/help.png" border="0" align="middle" title="'.jgall_parse_language('visit_us').'"></a>',
         );
         break;
         
      case "slideshow":
         $regs = array (
            'TITLE' => $jgall['dir_handle_current'] . ' [jgallery slideshow]',
            'META_REFRESH' => (($jgall['get']['slide'] != 'pause') && ($jgall['gall_items']['images'] > 1)) ? '<meta http-equiv="refresh" content="' . $jgall['config']['view_slideshow_timeout'] . ';url=?jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['tpl_array']['slideshow']['next_image'] . '&jgall_slide=' . $jgall['get']['slide'] . '" />' : '' ,
            'IMAGE' => $jgall['tpl_array']['slideshow']['image'],
            'IMAGE_NAME' => $jgall['get']['img'],
            'COUNTER' => jgall_parse_language('image_info'),
            'IMAGE_WIDTH' => $jgall['config']['view_slideshow_size']['image'],
            'BUTTON_FIRST' => ($jgall['get']['img'] != $jgall['gall_items']['first']) ? '<a href="?jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['gall_items']['first'] . '&jgall_slide=' . $jgall['get']['slide'] . '"><img src="template/'.$jgall['config']['template'].'/images/nav-first.png" border="0" align="middle">' : '',
            'BUTTON_BACK' => ($jgall['get']['img'] != $jgall['gall_items']['first']) ? '<a href="?jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['gall_items']['prev'] . '&jgall_slide=' . $jgall['get']['slide'] . '"><img src="template/'.$jgall['config']['template'].'/images/nav-back.png" border="0" align="middle"></a>' : '',
            'BUTTON_PAUSE' => (($jgall['get']['slide'] != 'pause') && ($jgall['gall_items']['images'] > 1)) ? '<a href="?jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['get']['img'] . '&jgall_slide=pause"><img src="template/'.$jgall['config']['template'].'/images/nav-pause.png" border="0" align="middle"></a>' : '<a href="?jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['tpl_array']['slideshow']['next_image'] . '&jgall_slide=play"><img src="template/'.$jgall['config']['template'].'/images/nav-play.png" border="0" align="middle"></a>',
            'BUTTON_NEXT' => ($jgall['get']['img'] != $jgall['gall_items']['last']) ? '<a href="?jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['gall_items']['next'] . '&jgall_slide=' . $jgall['get']['slide'] . '"><img src="template/'.$jgall['config']['template'].'/images/nav-next.png" border="0" align="middle"></a>' : '',
            'BUTTON_LAST' => ($jgall['get']['img'] != $jgall['gall_items']['last']) ? '<a href="?jgall_dir=' . $jgall['get']['dir'] . '&jgall_img=' . $jgall['gall_items']['last'] . '&jgall_slide=' . $jgall['get']['slide'] . '"><img src="template/'.$jgall['config']['template'].'/images/nav-last.png" border="0" align="middle"></a>' : '',
         );
         break;
         
      case "view_image":
         $regs = array (
            'IMAGE' => $jgall['tpl_array']['gallery']['image'],
         );
         break;
         
      case "thumb_image":
         $regs = array (
            'THUMB_MAXSIZE' => $jgall['config']['thumbnail_size'],
            'IMG_SRC' => $jgall['tpl_array']['gallery']['img_src'],
            'SIZE' => $jgall['tpl_array']['gallery']['thumb_demensions'],
            'LOCATION_HREF' => $jgall['tpl_array']['gallery']['location_href'],
            'TITLE' => $jgall['tpl_array']['gallery']['thumb_title'],
            'IMAGE_NAME' => (strlen($jgall['gall_items'][$jgall['i_pages']]['name']) > $jgall['config']['filename_length']) ? substr($jgall['gall_items'][$jgall['i_pages']]['name'],0,$jgall['config']['filename_length']) . '..' : $jgall['gall_items'][$jgall['i_pages']]['name'] ,
         );
         break;
         
      case "thumb_folder":
         $regs = array (
            'FOLDER_IMAGE' => $jgall['tpl_array']['gallery']['folderimage'] ,
            'THUMB_MAXSIZE' => $jgall['config']['thumbnail_size'],
            'LOCATION_HREF' => $jgall['tpl_array']['gallery']['location_href'],
            'FOLDER_THUMB' => $jgall['gall_items'][$jgall['i_pages']]['first_image'],
            'FOLDER_NAME' => (strlen($jgall['gall_items'][$jgall['i_pages']]['name']) > $jgall['config']['filename_length']) ? substr($jgall['gall_items'][$jgall['i_pages']]['name'],0,$jgall['config']['filename_length']) . '..' : $jgall['gall_items'][$jgall['i_pages']]['name'] ,
            'INFO_TITLE' => jgall_parse_language('folder_info')
         );
         break;
         
      case "pagelinks":
         $regs = array(
            'PAGELINKS' => $jgall['tpl_array']['pagelinks']['links'],
         );
         break;
         
      case "dir_info":
         $regs = array(
            'L_DIR_INFO' => (!empty($jgall['get']['img']) && file_exists($jgall['inc_path'].$jgall['dir_handle'].$jgall['get']['img'])) ? jgall_parse_language('image_detail') : jgall_parse_language('gall_detail') ,
         );
         break;
         
      case "html_footer":
         $regs = array(
         );
         break;
         
      case "emptydir":
         $regs = array(
            'L_EMPTYDIR' => $jgall['lang']['emptydir'],
         );
         break;
         
      default:
         $regs = array();
         break;
         
   }
   
   $regs = array_merge($global_regs,$regs);
   
   $output = file_get_contents($jgall['inc_path'] . 'template/' . $jgall['config']['template'] . '/' . $part . '.tpl');
   
   foreach($regs as $key => $value)
   {
   
      $output = preg_replace( '|({'.$key.'})|' , $value , $output );
      
   }
   
   return "\r\n" . $output . "\r\n";
   
} // end function jgall_parse_tpl



// ----------------------------------------------------------------------------------- 
// function to parse texts
// ----------------------------------------------------------------------------------- 
function jgall_parse_language($part)
{
   
   global $jgall;
   
   $global_regs = array (
      'HOMEDIR' => $jgall['lang']['mainfolder'],
      'VERSION' => $jgall['status']['build'],
      'B' => '<b>',
      '/B' => '</b>',
   );
   
   switch($part)
   {
   
      case "image_info":
         $regs = array(
            'CURRENT' => $jgall['gall_items']['current']['num'],
            'TOTAL' => $jgall['gall_items']['images'],
         );
         break;
   
      case "image_detail":
         $regs = array(
            'NAME' => $jgall['gall_items']['current']['name'],
            'WIDTH' => $jgall['gall_items']['current']['info'][0],
            'HEIGHT' => $jgall['gall_items']['current']['info'][1],
            'FILESIZE' => round($jgall['gall_items']['current']['size']/1000) ,
            'MIME' => $jgall['gall_items']['current']['info']['mime'],
         );
         break;
         
      case "folder_info":
         $regs = array(
            'DIR' => $jgall['gall_items'][$jgall['i_pages']]['name'],
            'IMAGES' => $jgall['gall_items'][$jgall['i_pages']]['content'][0],
            'FOLDERS' => $jgall['gall_items'][$jgall['i_pages']]['content'][1],
         );
         break;
         
      case "gall_detail":
         $regs = array(
            'FIRST' => $jgall['temp_start']+1,
            'LAST' => $jgall['max'],
            'TOTAL' => $jgall['gall_items']['total'],
            'FOLDERS' => $jgall['gall_items']['directorys'],
            'IMAGES' => $jgall['gall_items']['images'],
            'DIR' => $jgall['dir_handle_current'],
         );
         break;
         
      default:
         $regs = array();
         break;
         
   }
   
   $regs = array_merge($global_regs,$regs);
   
   $output = $jgall['lang'][$part];
   
   foreach($regs as $key => $value)
   {
   
      $output = preg_replace( '|({'.$key.'})|' , stripslashes($value) , $output );
      
   }
   
   return $output;
   
} // end function jgall_parse_language



// ----------------------------------------------------------------------------------- 
// function to calculate resized image size
// ----------------------------------------------------------------------------------- 
function jgall_resize($srcsize,$maxsize)
{
   $srcratio = $srcsize[0]/$srcsize[1];
   $destratio = $maxsize/$maxsize;
   if ($destratio > $srcratio)
   {
      $destsize[1] = $maxsize;
      $destsize[0] = $maxsize*$srcratio;
   }
   else 
   {
      $destsize[0] = $maxsize;
      $destsize[1] = $maxsize/$srcratio;
   }
   return 'width="' . round($destsize[0]) . '" height="' . round($destsize[1]) . '"';
} // end function jgall_resize



// ----------------------------------------------------------------------------------- 
// function to get users get-vars
// ----------------------------------------------------------------------------------- 
function jgall_usergets() 
{
   $usergets = '?';
   foreach ($_GET as $key => $value) 
   { 
      if (!eregi('jgall_',$key)) 
      { 
         $usergets .= htmlentities(strip_tags($key)) . '=' . htmlentities(strip_tags($value)); 
         $usergets .= ($usergets) ? '&' : '?'; 
      } 
   } 
   return str_replace('../','',strip_tags(str_replace('\\','',$usergets)));
} 



// ----------------------------------------------------------------------------------- 
// function echo's global arrays for debugging
// ----------------------------------------------------------------------------------- 
function jgall_vardump()
{
   global $jgall;
   echo '<div align="left"><pre><code>';
   if($_GET['debug'] != 'all')
   {
      unset(
         $jgall['nav_output_top'] ,
         $jgall['nav_output_bottom'] ,
         $jgall['output_location'] ,
         $jgall['output_pagelinks'] ,
         $jgall['output_spacing'] ,
         $jgall['image_link_start'] ,
         $jgall['image_link_end']
      );
   }
   print_r($jgall);
   echo '</code></pre></div>';
   echo '<a href="?jgall_dir='.$jgall['get']['dir'].'&jgall_page='.$jgall['get']['page'].'&jgall_img='.$jgall['get']['img'].'">stop debugging</a>';
}


// -------------------------------------------------------------------------------------
// function writes array values to file in php syntax
// -------------------------------------------------------------------------------------
function jgall_array2file($save, $file, $name='data', $level='0') 
{
   $succes = false;
   if($level > '0')
   {
      $sp = '';
      $temp = '';
      for($i='0'; $i < $level; $i++)
      {
         $sp .= "\t";
      }
      foreach($save as $key => $val)
      {    
         if(is_array($val))
         {  
            $temp .= $sp . '\'' . $key . '\' => array(' . "\r\n" . 
                     jgall_array2file($val,0,0,$level+1) . $sp . '),' . "\r\n"; 
         }    
         else
         { 
            $temp .= $sp . '\'' . $key . '\' => \'' . $val . '\',' . "\r\n";    
         }    
      } return($temp);   
   }   
   else
   { 
      $content = '<?php'."\r\n" . '// saved: '.date("y m d, h:i")."\r\n" . '$' . $name . ' = ' . "\r\n" . 'array(' . "\r\n" . jgall_array2file($save,0,0,1).');' . "\r\n" . '?'.'>';   
      if(fwrite(fopen($file,"w+"),$content))
      {    
          $succes = true;
      }   
   } return($succes);   
} // --> end function jgall_array2file

// --> end
?>
